| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::RTShader::ProgramWriterManager Class Reference
Optional Components » RTShaderSystem

`#include <OgreShaderProgramWriterManager.h>`

Inheritance diagram for Ogre::RTShader::ProgramWriterManager:
[legend]

## Public Types
typedef std::map< String, ProgramWriterFactory * > | FactoryMap

## Public Member Functions
| ProgramWriterManager ()
| ~ProgramWriterManager ()
void | addFactory (ProgramWriterFactory *factory)
| Add a new factory object for high-level programs of a given language. More...
ProgramWriter * | createProgramWriter (const String &language)
| Create a new, unloaded HighLevelGpuProgram. More...
bool | isLanguageSupported (const String &lang)
| Returns whether a given high-level language is supported. More...
void | removeFactory (ProgramWriterFactory *factory)
| Remove a factory object for high-level programs of a given language. More...

## Static Public Member Functions
static ProgramWriterManager & | getSingleton ()
| Override standard Singleton retrieval. More...
static ProgramWriterManager * | getSingletonPtr ()
| Get the singleton instance. More...

## Member Typedef Documentation

## ◆ FactoryMap

typedef std::map<String, ProgramWriterFactory*> Ogre::RTShader::ProgramWriterManager::FactoryMap

## Constructor & Destructor Documentation

## ◆ ProgramWriterManager()

Ogre::RTShader::ProgramWriterManager::ProgramWriterManager | ( |  | ) |

## ◆ ~ProgramWriterManager()

Ogre::RTShader::ProgramWriterManager::~ProgramWriterManager | ( |  | ) |

## Member Function Documentation

## ◆ addFactory()

void Ogre::RTShader::ProgramWriterManager::addFactory | ( | ProgramWriterFactory * | factory | ) |

Add a new factory object for high-level programs of a given language.

## ◆ removeFactory()

void Ogre::RTShader::ProgramWriterManager::removeFactory | ( | ProgramWriterFactory * | factory | ) |

Remove a factory object for high-level programs of a given language.

## ◆ isLanguageSupported()

bool Ogre::RTShader::ProgramWriterManager::isLanguageSupported | ( | const String & | lang | ) |

Returns whether a given high-level language is supported.

## ◆ createProgramWriter()

ProgramWriter* Ogre::RTShader::ProgramWriterManager::createProgramWriter | ( | const String & | language | ) |

Create a new, unloaded HighLevelGpuProgram.

  This method creates a new program of the type specified as the second and third parameters. You will have to call further methods on the returned program in order to define the program fully before you can load it.

Parameters

  language | Code of the language to use (e.g. "cg")

## ◆ getSingleton()

static ProgramWriterManager& Ogre::RTShader::ProgramWriterManager::getSingleton | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static ProgramWriterManager* Ogre::RTShader::ProgramWriterManager::getSingletonPtr | ( |  | ) |
| static

Get the singleton instance.

The documentation for this class was generated from the following file:

- OgreShaderProgramWriterManager.h